#include "MLRHeaders.hpp"

//#############################################################################
//###### MLRIndexedPolyMesh with no color no lighting two texture layer  ######
//#############################################################################

MLR_I_DT_PMesh::ClassData*
	MLR_I_DT_PMesh::DefaultData = NULL;

DynamicArrayOf<Vector2DScalar>
	*MLR_I_DT_PMesh::clipExtraTexCoords2;
DynamicArrayOf<Vector2DScalar>
	*MLR_I_DT_PMesh::texCoords2;

HGOSHEAP
	MLR_I_DT_PMesh::PrimitiveHeap = NULL;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
void
	MLR_I_DT_PMesh::InitializeClass()
{
	Verify(!PrimitiveHeap);
	PrimitiveHeap = gos_CreateMemoryHeap("MLR_I_DT_PMesh", 0, MidLevelRenderer::PrimitiveHeap);
	Check_Pointer(PrimitiveHeap);

	Verify(!DefaultData);
	Verify(gos_GetCurrentHeap() == StaticHeap);
	DefaultData =
		new ClassData(
			MLR_I_DT_PMeshClassID,
			"MidLevelRenderer::MLR_I_DT_PMesh",
			MLR_I_PMesh::DefaultData,
			(MLRPrimitiveBase::Factory)&Make
		);
	Register_Object(DefaultData);
	
	clipExtraTexCoords2 = new DynamicArrayOf<Vector2DScalar>;
	Register_Object(clipExtraTexCoords2);
	clipExtraTexCoords2->SetLength(2*Limits::Max_Number_Vertices_Per_Mesh);

	texCoords2 = new DynamicArrayOf<Vector2DScalar>;
	Register_Object(texCoords2);
	texCoords2->SetLength(Limits::Max_Number_Vertices_Per_Mesh);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
void
	MLR_I_DT_PMesh::TerminateClass()
{
	Unregister_Object(clipExtraTexCoords2);
	delete clipExtraTexCoords2;
	Unregister_Object(texCoords2);
	delete texCoords2;

	Unregister_Object(DefaultData);
	delete DefaultData;
	DefaultData = NULL;

	Check_Pointer(PrimitiveHeap);
	gos_DestroyMemoryHeap(PrimitiveHeap);
	PrimitiveHeap = NULL;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
MLR_I_DT_PMesh::MLR_I_DT_PMesh(
	ClassData *class_data,
	MemoryStream *stream,
	int version
):
	MLR_I_PMesh(class_data, stream, version)
{
	Check_Pointer(this);
	Check_Pointer(stream);

	gos_PushCurrentHeap(StatesHeap);
	referenceState2.Load(stream, version);
	gos_PopCurrentHeap();

	referenceState2.SetZBufferWriteOff();

	referenceState.SetPriority(MLRState::DefaultPriority);
	referenceState2.SetPriority(MLRState::DefaultPriority);

#if 0
	referenceState.SetPriority(MLRState::DefaultPriority+1);

	referenceState2.SetAlphaMode(MLRState::OneZeroMode);
	referenceState.SetAlphaMode(MLRState::AlphaInvAlphaMode);
#endif

	passes = 2;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
MLR_I_DT_PMesh::MLR_I_DT_PMesh(ClassData *class_data):
	MLR_I_PMesh(class_data)
{
	Check_Pointer(this);

	passes = 2;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
MLR_I_DT_PMesh::~MLR_I_DT_PMesh()
{
	Check_Object(this);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
MLR_I_DT_PMesh*
	MLR_I_DT_PMesh::Make(
		MemoryStream *stream,
		int version
	)
{
	Check_Object(stream);

	gos_PushCurrentHeap(PrimitiveHeap);
	MLR_I_DT_PMesh *mesh = new MLR_I_DT_PMesh(DefaultData, stream, version);
	gos_PopCurrentHeap();

	return mesh;
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
void
	MLR_I_DT_PMesh::Save(MemoryStream *stream)
{
	Check_Object(this);
	Check_Object(stream);

	MLR_I_PMesh::Save(stream);

	referenceState2.Save(stream);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
void
	MLR_I_DT_PMesh::TestInstance() const
{
	Verify(IsDerivedFrom(DefaultData));
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
void
	MLR_I_DT_PMesh::SetTexCoordData(
		const Vector2DScalar *data,
		int dataSize
	)
{
	Check_Object(this); 
	Check_Pointer(data);

	Verify(coords.GetLength() == 0 || dataSize == 2*coords.GetLength());

	texCoords.AssignData((Vector2DScalar *)data, dataSize);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
bool
	MLR_I_DT_PMesh::Copy(MLR_I_DT_TMesh *tmesh)
{
	Check_Object(tmesh);

	MLR_I_PMesh::Copy(tmesh);

	referenceState2 = tmesh->GetReferenceState(1);

	return true;
}

#define I_SAY_YES_TO_DUAL_TEXTURES
#undef I_SAY_YES_TO_COLOR
#undef I_SAY_YES_TO_LIGHTING

#define CLASSNAME MLR_I_DT_PMesh

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//	This include contains follwing functions:
//	void MLR_I_DT_PMesh::TransformNoClip(Matrix4D*, GOSVertexPool*);
//	int MLR_I_DT_PMesh::Clip(MLRClippingState, GOSVertexPool*);
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include <MLR\MLRPrimitiveClipping.hpp>

#undef I_SAY_YES_TO_DUAL_TEXTURES
#undef CLASSNAME

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
MLR_I_DT_PMesh*
	MidLevelRenderer::CreateIndexedCube_NoColor_NoLit_2Tex(
		Scalar half, 
		MLRState *state,
		MLRState *state2
	)
{
	gos_PushCurrentHeap(PrimitiveHeap);
	MLR_I_DT_PMesh *ret = new MLR_I_DT_PMesh();
	Check_Object(ret);

	DynamicArrayOf<Point3D> *coords = &ret->dataStore->coords;
	coords->SetLength(8);
	Check_Object(coords);

	(*coords)[0] = Point3D( half, -half,  half);
	(*coords)[1] = Point3D(-half, -half,  half);
	(*coords)[2] = Point3D( half, -half, -half);
	(*coords)[3] = Point3D(-half, -half, -half);
	(*coords)[4] = Point3D(-half,  half,  half);
	(*coords)[5] = Point3D( half,  half,  half);
	(*coords)[6] = Point3D( half,  half, -half);
	(*coords)[7] = Point3D(-half,  half, -half);

	DynamicArrayOf<BYTE> *lengths = &ret->dataStore->lengths;
	lengths->SetLength(6);
	Register_Pointer(lengths);

	int i;

	for(i=0;i<6;i++)
	{
		(*lengths)[i] = 4;
	}

	ret->SetSubprimitiveLengths(lengths->GetData(), 6);

	ret->SetCoordData(coords->GetData(), 8);

	DynamicArrayOf<BYTE> *index = &ret->dataStore->index;
	index->SetLength(24);
	Register_Pointer(index);

	(*index)[0] = 0;
	(*index)[1] = 2;
	(*index)[2] = 6;
	(*index)[3] = 5;

	(*index)[4] = 0;
	(*index)[5] = 5;
	(*index)[6] = 4;
	(*index)[7] = 1;

	(*index)[8] = 5;
	(*index)[9] = 6;
	(*index)[10] = 7;
	(*index)[11] = 4;

	(*index)[12] = 2;
	(*index)[13] = 3;
	(*index)[14] = 7;
	(*index)[15] = 6;

	(*index)[16] = 1;
	(*index)[17] = 4;
	(*index)[18] = 7;
	(*index)[19] = 3;

	(*index)[20] = 0;
	(*index)[21] = 1;
	(*index)[22] = 3;
	(*index)[23] = 2;

	ret->SetIndexData(index->GetData(), 6*4);

	ret->FindFacePlanes();

	DynamicArrayOf<Vector2DScalar> *texCoords = &ret->dataStore->texCoords;
	Register_Pointer(texCoords);
	texCoords->SetLength(16);

	for(i=0;i<16;i++)
	{
		(*texCoords)[i] = Vector2DScalar(0.0f, 0.0f);
	}

	if(state != NULL)
	{
		ret->SetReferenceState(*state);
		if(state->GetTextureHandle() > 0)
		{
			(*texCoords)[0] = Vector2DScalar(0.0f, 0.0f);
			(*texCoords)[1] = Vector2DScalar(1.0f, 0.0f);
			(*texCoords)[2] = Vector2DScalar(0.25f, 0.25f);
			(*texCoords)[3] = Vector2DScalar(0.75f, 0.25f);

			(*texCoords)[4] = Vector2DScalar(1.0f, 1.0f);
			(*texCoords)[5] = Vector2DScalar(0.0f, 1.0f);
			(*texCoords)[6] = Vector2DScalar(0.25f, 0.75f);
			(*texCoords)[7] = Vector2DScalar(0.75f, 0.75f);
		}
	}

	if(state2 != NULL)
	{
		ret->SetReferenceState(*state, 1);
		if(state2->GetTextureHandle() > 0)
		{
			(*texCoords)[8] = Vector2DScalar(0.0f, 0.0f);
			(*texCoords)[9] = Vector2DScalar(1.0f, 0.0f);
			(*texCoords)[10] = Vector2DScalar(0.25f, 0.25f);
			(*texCoords)[11] = Vector2DScalar(0.75f, 0.25f);

			(*texCoords)[12] = Vector2DScalar(1.0f, 1.0f);
			(*texCoords)[13] = Vector2DScalar(0.0f, 1.0f);
			(*texCoords)[14] = Vector2DScalar(0.25f, 0.75f);
			(*texCoords)[15] = Vector2DScalar(0.75f, 0.75f);
		}
	}
	
	ret->SetTexCoordData(texCoords->GetData(), 16);

	gos_PopCurrentHeap();
	return ret;
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
MLRShape*
	MidLevelRenderer::CreateIndexedIcosahedron_NoColor_NoLit_2Tex(
		IcoInfo& icoInfo,
		MLRState *state,
		MLRState *state2
	)
{
	gos_PushCurrentHeap(ShapeHeap);
	MLRShape *ret = new MLRShape(20);
	Register_Object(ret);
	gos_PopCurrentHeap();

	gos_PushCurrentHeap(PrimitiveHeap);
	int i, j, k;
	long    nrTri = (long) ceil (icoInfo.all * pow (4, icoInfo.depth));
	Point3D v[3];

	if(3*nrTri >= Limits::Max_Number_Vertices_Per_Mesh)
	{
		nrTri = Limits::Max_Number_Vertices_Per_Mesh/3;
	}

	int uniquePoints = 0;
	for (k=0;k<20;k++)
	{
		triDrawn = 0;
		MLR_I_DT_PMesh *mesh = new MLR_I_DT_PMesh();
		Register_Object(mesh);

		DynamicArrayOf<BYTE> *lengths = &mesh->dataStore->lengths;
		Check_Object(lengths);
		lengths->SetLength(nrTri);

		for(i=0;i<nrTri;i++)
		{
			(*lengths)[i] = 3;
		}

		DynamicArrayOf<Point3D> *coords = &mesh->dataStore->coords;
		Check_Object(coords);
		coords->SetLength(nrTri*3);

		DynamicArrayOf<BYTE> *index = &mesh->dataStore->index;
		Check_Object(index);
		index->SetLength(nrTri*3);

		DynamicArrayOf<Vector2DScalar> *texCoords = &mesh->dataStore->texCoords;
		Check_Object(texCoords);
		texCoords->SetLength(2*nrTri*3);

// setup vertex position information
	    for (j=0;j<3;j++)
		{
			v[j].x = vdata[tindices[k][j]][0];
			v[j].y = vdata[tindices[k][j]][1];
			v[j].z = vdata[tindices[k][j]][2];
		}
		subdivide (coords->GetData(), v[0], v[1], v[2], icoInfo.depth, nrTri, icoInfo.radius);

		mesh->SetSubprimitiveLengths(lengths->GetData(), nrTri);


		if(icoInfo.indexed==true)
		{
			uniquePoints = 1;
			Point3D *collapsedCoords = new Point3D [nrTri*3];
			Register_Pointer(collapsedCoords);

			collapsedCoords[0] = (*coords)[0];
			(*index)[0] = 0;

			for(i=1;i<nrTri*3;i++)
			{
				for(j=0;j<uniquePoints;j++)
				{
					if((*coords)[i] == collapsedCoords[j])
					{
						break;
					}
				}
				if(j==uniquePoints)
				{
					collapsedCoords[uniquePoints++] = (*coords)[i];
				}
				(*index)[i] = static_cast<BYTE>(j);
			}
			coords->AssignData(collapsedCoords, uniquePoints);
			mesh->SetCoordData(coords->GetData(), uniquePoints);
			Check_Pointer(collapsedCoords);
			delete [] collapsedCoords;
		}
		else
		{
			uniquePoints = nrTri*3;
			for(i=0;i<nrTri*3;i++)
			{
				(*index)[i] = static_cast<BYTE>(i);
			}
			mesh->SetCoordData(coords->GetData(), nrTri*3);
		}

		mesh->SetIndexData(index->GetData(), nrTri*3);

		mesh->FindFacePlanes();

		if(state == NULL)
		{
			for(i=0;i<2*uniquePoints;i++)
			{
				(*texCoords)[i] = Vector2DScalar(0.0f, 0.0f);
			}
		}
		else
		{
			mesh->SetReferenceState(*state);
			if(state->GetTextureHandle() > 0)
			{
				for(i=0;i<uniquePoints;i++)
				{
					(*texCoords)[i] = 
						Vector2DScalar(
							(1.0f + (*coords)[i].x)/2.0f,
							(1.0f + (*coords)[i].y)/2.0f
						);
					(*texCoords)[i+uniquePoints] = 
						Vector2DScalar(
							(1.0f + (*coords)[i].x)/2.0f,
							(1.0f + (*coords)[i].z)/2.0f
						);
				}
			}
			else
			{
				for(i=0;i<2*uniquePoints;i++)
				{
					(*texCoords)[i] = Vector2DScalar(0.0f, 0.0f);
				}
			}
		}
		mesh->SetTexCoordData(texCoords->GetData(), 2*uniquePoints);

		mesh->SetReferenceState(*state2);

		ret->Add(mesh);
		mesh->DetachReference();
	}

	gos_PopCurrentHeap();
	return ret;
}
